# Generated by ariadne-codegen
# Source: queries.graphql

from typing import Any, List, Optional

from pydantic import Field

from .base_model import BaseModel
from .enums import AlgoRunningStatus, MMAlgoKind, ReferencePrice


class GetSpreadStatus(BaseModel):
    spread_algo_status: List["GetSpreadStatusSpreadAlgoStatus"] = Field(
        alias="spreadAlgoStatus"
    )


class GetSpreadStatusSpreadAlgoStatus(BaseModel):
    order_id: Any = Field(alias="orderId")
    order: Optional["GetSpreadStatusSpreadAlgoStatusOrder"]
    creation_time: Any = Field(alias="creationTime")
    status: AlgoRunningStatus
    position: Any
    hedge_position: Any = Field(alias="hedgePosition")
    miss_ratio: Any = Field(alias="missRatio")
    effective_spread: Optional[Any] = Field(alias="effectiveSpread")
    buy_status: "GetSpreadStatusSpreadAlgoStatusBuyStatus" = Field(alias="buyStatus")
    sell_status: "GetSpreadStatusSpreadAlgoStatusSellStatus" = Field(alias="sellStatus")
    kind: MMAlgoKind


class GetSpreadStatusSpreadAlgoStatusOrder(BaseModel):
    name: str
    order_id: Any = Field(alias="orderId")
    market_id: Any = Field(alias="marketId")
    quantity_buy: Any = Field(alias="quantityBuy")
    quantity_sell: Any = Field(alias="quantitySell")
    min_position: Any = Field(alias="minPosition")
    max_position: Any = Field(alias="maxPosition")
    max_improve_bbo: Any = Field(alias="maxImproveBbo")
    position_tilt: Any = Field(alias="positionTilt")
    reference_price: ReferencePrice = Field(alias="referencePrice")
    ref_dist_frac: Any = Field(alias="refDistFrac")
    tolerance_frac: Any = Field(alias="toleranceFrac")
    account: Optional[Any]


class GetSpreadStatusSpreadAlgoStatusBuyStatus(BaseModel):
    last_order_time: Any = Field(alias="lastOrderTime")
    last_fill_time: Any = Field(alias="lastFillTime")
    last_reject_time: Any = Field(alias="lastRejectTime")
    open_order: Optional["GetSpreadStatusSpreadAlgoStatusBuyStatusOpenOrder"] = Field(
        alias="openOrder"
    )
    reference_price: Optional[Any] = Field(alias="referencePrice")


class GetSpreadStatusSpreadAlgoStatusBuyStatusOpenOrder(BaseModel):
    order_id: Any = Field(alias="orderId")
    price: Any
    quantity: Any
    cancel_pending: bool = Field(alias="cancelPending")


class GetSpreadStatusSpreadAlgoStatusSellStatus(BaseModel):
    last_order_time: Any = Field(alias="lastOrderTime")
    last_fill_time: Any = Field(alias="lastFillTime")
    last_reject_time: Any = Field(alias="lastRejectTime")
    open_order: Optional["GetSpreadStatusSpreadAlgoStatusSellStatusOpenOrder"] = Field(
        alias="openOrder"
    )
    reference_price: Optional[Any] = Field(alias="referencePrice")


class GetSpreadStatusSpreadAlgoStatusSellStatusOpenOrder(BaseModel):
    order_id: Any = Field(alias="orderId")
    price: Any
    quantity: Any
    cancel_pending: bool = Field(alias="cancelPending")


GetSpreadStatus.model_rebuild()
GetSpreadStatusSpreadAlgoStatus.model_rebuild()
GetSpreadStatusSpreadAlgoStatusBuyStatus.model_rebuild()
GetSpreadStatusSpreadAlgoStatusSellStatus.model_rebuild()
